--- old/usr/src/uts/common/io/comstar/port/qlt/qlt.c	Mon Aug  5 17:27:33 2019
+++ new/usr/src/uts/common/io/comstar/port/qlt/qlt.c	Mon Aug  5 17:27:33 2019
@@ -5573,23 +8752,103 @@
 	REG_WR32(qlt, 0x54, 0x61B0);
 	n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
 	buf += n; size_left -= n;
-	if (qlt->qlt_81xx_chip) {
+	if ((qlt->qlt_83xx_chip) || (qlt->qlt_81xx_chip)) {
 		REG_WR32(qlt, 0x54, 0x61C0);
 		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
 		buf += n; size_left -= n;
 	}
-	if ((qlt->qlt_25xx_chip) || (qlt->qlt_81xx_chip)) {
+	if (qlt->qlt_83xx_chip) {
+		REG_WR32(qlt, 0x54, 0x6530);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x6540);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x6550);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x6560);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x6570);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x6580);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x6590);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x65A0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x65B0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x65C0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x65D0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x65E0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+	}
+	if ((qlt->qlt_25xx_chip) || (qlt->qlt_81xx_chip) ||
+	    (qlt->qlt_83xx_chip)) {
 		REG_WR32(qlt, 0x54, 0x6F00);
 		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
 		buf += n; size_left -= n;
 	}
 
+	if (qlt->qlt_83xx_chip) {
+		n = (int)snprintf(buf, size_left, "\nAT0 Array registers\n");
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x7080);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x7090);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x70A0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x70B0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x70C0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x70D0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x70E0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+		REG_WR32(qlt, 0x54, 0x70F0);
+		n = qlt_fwdump_dump_regs(qlt, buf, 0xc0, 16, size_left);
+		buf += n; size_left -= n;
+	}
+
+	EL(qlt, "reset chip\n");
 	qlt->intr_sneak_counter = 10;
 	mutex_enter(&qlt->intr_lock);
+	if (qlt->qlt_mq_enabled) {
+		for (i = 1; i < qlt->qlt_queue_cnt; i++) {
+			mutex_enter(&qlt->mq_resp[i].mq_lock);
+		}
+	}
 	(void) qlt_reset_chip(qlt);
 	drv_usecwait(20);
 	qlt->intr_sneak_counter = 0;
+	if (qlt->qlt_mq_enabled) {
+		for (i = 1; i < qlt->qlt_queue_cnt; i++) {
+			mutex_exit(&qlt->mq_resp[i].mq_lock);
+		}
+	}
 	mutex_exit(&qlt->intr_lock);
+	EL(qlt, "reset chip, done\n");
 
 	/*
 	 * Memory
@@ -5598,7 +8857,7 @@
 	buf += n; size_left -= n;
 
 	addr = 0x20000;
-	endaddr = 0x22000;
+	endaddr = (qlt->qlt_83xx_chip) ? 0x22400 : 0x22000;
 	words_to_read = 0;
 	while (addr < endaddr) {
 		words_to_read = MBOX_DMA_MEM_SIZE >> 2;
@@ -5665,23 +8924,64 @@
 	 */
 	n = (int)snprintf(buf, size_left, "\nRequest Queue\n");
 	buf += n; size_left -= n;
-	n = qlt_dump_queue(qlt, qlt->queue_mem_ptr + REQUEST_QUEUE_OFFSET,
-	    REQUEST_QUEUE_ENTRIES, buf, size_left);
-	buf += n; size_left -= n;
 
-	n = (int)snprintf(buf, size_left, "\nPriority Queue\n");
-	buf += n; size_left -= n;
-	n = qlt_dump_queue(qlt, qlt->queue_mem_ptr + PRIORITY_QUEUE_OFFSET,
-	    PRIORITY_QUEUE_ENTRIES, buf, size_left);
-	buf += n; size_left -= n;
+	if (qlt->qlt_mq_enabled) {
+		for (i = 0; i < qlt->qlt_queue_cnt; i++) {
+			if (qlt->mq_req[i].queue_mem_mq_base_addr) {
+				n = (int)snprintf(buf, size_left,
+				    "\nQueue %d:\n", i);
+				buf += n; size_left -= n;
+				n = qlt_dump_queue(qlt,
+				    qlt->mq_req[i].queue_mem_mq_base_addr,
+				    REQUEST_QUEUE_MQ_ENTRIES,
+				    buf, size_left);
+				buf += n; size_left -= n;
+			}
+		}
+	} else {
+		n = (int)snprintf(buf, size_left, "\nQueue 0:\n");
+		buf += n; size_left -= n;
+		n = qlt_dump_queue(qlt,
+		    qlt->queue_mem_ptr + REQUEST_QUEUE_OFFSET,
+		    REQUEST_QUEUE_ENTRIES, buf, size_left);
+		buf += n; size_left -= n;
+	}
 
+	if (!qlt->qlt_83xx_chip) {
+		n = (int)snprintf(buf, size_left, "\nPriority Queue\n");
+		buf += n; size_left -= n;
+		n = qlt_dump_queue(qlt,
+		    qlt->queue_mem_ptr + PRIORITY_QUEUE_OFFSET,
+		    PRIORITY_QUEUE_ENTRIES, buf, size_left);
+		buf += n; size_left -= n;
+	}
+
 	n = (int)snprintf(buf, size_left, "\nResponse Queue\n");
 	buf += n; size_left -= n;
-	n = qlt_dump_queue(qlt, qlt->queue_mem_ptr + RESPONSE_QUEUE_OFFSET,
-	    RESPONSE_QUEUE_ENTRIES, buf, size_left);
-	buf += n; size_left -= n;
 
-	n = (int)snprintf(buf, size_left, "\nATIO queue\n");
+	if (qlt->qlt_mq_enabled) {
+		for (i = 0; i < qlt->qlt_queue_cnt; i++) {
+			if (qlt->mq_resp[i].queue_mem_mq_base_addr) {
+				n = (int)snprintf(buf, size_left,
+				    "\nQueue %d:\n", i);
+				buf += n; size_left -= n;
+				n = qlt_dump_queue(qlt,
+				    qlt->mq_resp[i].queue_mem_mq_base_addr,
+				    RESPONSE_QUEUE_MQ_ENTRIES,
+				    buf, size_left);
+				buf += n; size_left -= n;
+			}
+		}
+	} else {
+		n = (int)snprintf(buf, size_left, "\nQueue 0:\n");
+		buf += n; size_left -= n;
+		n = qlt_dump_queue(qlt,
+		    qlt->queue_mem_ptr + RESPONSE_QUEUE_OFFSET,
+		    RESPONSE_QUEUE_ENTRIES, buf, size_left);
+		buf += n; size_left -= n;
+	}
+
+	n = (int)snprintf(buf, size_left, "\nATIO Queue\nQueue 0:\n");
 	buf += n; size_left -= n;
 	n = qlt_dump_queue(qlt, qlt->queue_mem_ptr + ATIO_QUEUE_OFFSET,
 	    ATIO_QUEUE_ENTRIES, buf, size_left);
@@ -5690,13 +8990,19 @@
 	/*
 	 * Label dump reason
 	 */
-	n = (int)snprintf(buf, size_left, "\nFirmware dump reason: %s-%s\n",
-	    qlt->qlt_port_alias, ssci->st_additional_info);
+	if (ssci != NULL) {
+		n = (int)snprintf(buf, size_left,
+		    "\nFirmware dump reason: %s-%s\n",
+		    qlt->qlt_port_alias, ssci->st_additional_info);
+	} else {
+		n = (int)snprintf(buf, size_left,
+		    "\nFirmware dump reason: %s-%s\n",
+		    qlt->qlt_port_alias, "no additional infor");
+	}
 	buf += n; size_left -= n;
 
 dump_ok:
 	EL(qlt, "left-%d\n", size_left);
-
 	mutex_enter(&qlt->qlt_ioctl_lock);
 	qlt->qlt_ioctl_flags &=
 	    ~(QLT_FWDUMP_INPROGRESS | QLT_FWDUMP_FETCHED_BY_USER);
@@ -5766,11 +9072,11 @@
 	int		n;
 	char		c = ' ';
 	int		words;
-	uint16_t	*ptr;
-	uint16_t	w;
+	uint32_t	*ptr;
+	uint32_t	w;
 
-	words = entries * 32;
-	ptr = (uint16_t *)qadr;
+	words = entries * 16;
+	ptr = (uint32_t *)qadr;
 	for (i = 0, n = 0; i < words; i++) {
 		if ((i & 7) == 0) {
 			n = (int)(n + (int)snprintf(&buf[n],
@@ -5781,8 +9087,8 @@
 		} else {
 			c = '\n';
 		}
-		w = QMEM_RD16(qlt, &ptr[i]);
-		n = (int)(n + (int)snprintf(&buf[n], (size_left - n), "%04x%c",
+		w = QMEM_RD32(qlt, &ptr[i]);
+		n = (int)(n + (int)snprintf(&buf[n], (size_left - n), "%08x%c",
 		    w, c));
 	}
 	return (n);
@@ -5823,21 +9129,60 @@
 		(void) ddi_dma_sync(qlt->queue_mem_dma_handle,
 		    MBOX_DMA_MEM_OFFSET, words << 2, DDI_DMA_SYNC_FORCPU);
 	} else {
-		EL(qlt, "qlt_raw_mailbox_command=ch status=%llxh\n", ret);
+		EL(qlt, "qlt_raw_mailbox_command=0x0ch status=%llxh\n", ret);
 	}
 	return (ret);
 }
 
+static fct_status_t
+qlt_mbx_mpi_ram(qlt_state_t *qlt, uint32_t addr, uint32_t words,
+    uint16_t direction)
+{
+	uint64_t	da;
+	fct_status_t	ret;
+
+	REG_WR16(qlt, REG_MBOX(0), MBC_MPI_RAM);
+	da = qlt->queue_mem_cookie.dmac_laddress;
+	da += MBOX_DMA_MEM_OFFSET;
+
+	/* System destination address */
+	REG_WR16(qlt, REG_MBOX(3), LSW(LSD(da)));
+	REG_WR16(qlt, REG_MBOX(2), MSW(LSD(da)));
+	REG_WR16(qlt, REG_MBOX(7), LSW(MSD(da)));
+	REG_WR16(qlt, REG_MBOX(6), MSW(MSD(da)));
+
+	/* Length */
+	REG_WR16(qlt, REG_MBOX(5), LSW(words));
+	REG_WR16(qlt, REG_MBOX(4), MSW(words));
+
+	/* RISC source address */
+	REG_WR16(qlt, REG_MBOX(1), LSW(addr));
+	REG_WR16(qlt, REG_MBOX(8), MSW(addr));
+
+	REG_WR16(qlt, REG_MBOX(9), direction);
+	ret = qlt_raw_mailbox_command(qlt);
+	REG_WR32(qlt, REG_HCCR, HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
+	if (ret == QLT_SUCCESS) {
+		(void) ddi_dma_sync(qlt->queue_mem_dma_handle,
+		    MBOX_DMA_MEM_OFFSET, words << 2, DDI_DMA_SYNC_FORCPU);
+	} else {
+		EL(qlt, "qlt_raw_mailbox_command=0x05h status=%llxh\n", ret);
+	}
+	return (ret);
+}
+
 static void
 qlt_verify_fw(qlt_state_t *qlt)
 {
 	caddr_t req;
+	uint16_t qi = 0;
+
 	/* Just put it on the request queue */
-	mutex_enter(&qlt->req_lock);
-	req = qlt_get_req_entries(qlt, 1);
+	mutex_enter(&qlt->mq_req[qi].mq_lock);
+	req = qlt_get_req_entries(qlt, 1, qi);
 	if (req == NULL) {
-		mutex_exit(&qlt->req_lock);
-		/* XXX handle this */
+		EL(qlt, "req = NULL\n");
+		mutex_exit(&qlt->mq_req[qi].mq_lock);
 		return;
 	}
 
@@ -5850,28 +9195,153 @@
 	QMEM_WR16(qlt, (&req[0x8]), 1);    /*  options - don't update */
 	QMEM_WR32(qlt, (&req[0x14]), 0x80010300);
 
-	qlt_submit_req_entries(qlt, 1);
-	mutex_exit(&qlt->req_lock);
+	qlt_submit_req_entries(qlt, 1, qi);
+	mutex_exit(&qlt->mq_req[qi].mq_lock);
 }
 
+static fct_status_t
+qlt_mq_destroy(qlt_state_t *qlt)
+{
+	int idx;
+
+	for (idx = 1; idx < qlt->qlt_queue_cnt; idx++) {
+		(void) ddi_dma_unbind_handle(
+		    qlt->mq_req[idx].queue_mem_mq_dma_handle);
+		ddi_dma_mem_free(&qlt->mq_req[idx].queue_mem_mq_acc_handle);
+		ddi_dma_free_handle(&qlt->mq_req[idx].queue_mem_mq_dma_handle);
+		(void) ddi_dma_unbind_handle(
+		    qlt->mq_resp[idx].queue_mem_mq_dma_handle);
+		ddi_dma_mem_free(&qlt->mq_resp[idx].queue_mem_mq_acc_handle);
+		ddi_dma_free_handle(&qlt->mq_resp[idx].queue_mem_mq_dma_handle);
+	}
+	return (QLT_SUCCESS);
+}
+
+static fct_status_t
+qlt_mq_create(qlt_state_t *qlt, int idx)
+{
+	ddi_device_acc_attr_t dev_acc_attr;
+	size_t discard;
+	uint_t ncookies;
+
+	dev_acc_attr.devacc_attr_version = DDI_DEVICE_ATTR_V0;
+	dev_acc_attr.devacc_attr_endian_flags = DDI_STRUCTURE_LE_ACC;
+	dev_acc_attr.devacc_attr_dataorder = DDI_STRICTORDER_ACC;
+
+	/*
+	 * MQ Request queue
+	 */
+	if (ddi_dma_alloc_handle(qlt->dip, &qlt_queue_dma_attr_mq_req1,
+	    DDI_DMA_SLEEP, 0,
+	    &qlt->mq_req[idx].queue_mem_mq_dma_handle) != DDI_SUCCESS) {
+		return (QLT_FAILURE);
+	}
+	if (ddi_dma_mem_alloc(qlt->mq_req[idx].queue_mem_mq_dma_handle,
+	    REQUEST_QUEUE_MQ_SIZE,
+	    &dev_acc_attr, DDI_DMA_CONSISTENT, DDI_DMA_SLEEP, 0,
+	    &qlt->mq_req[idx].queue_mem_mq_base_addr, &discard,
+	    &qlt->mq_req[idx].queue_mem_mq_acc_handle) != DDI_SUCCESS) {
+		ddi_dma_free_handle(&qlt->mq_req[idx].queue_mem_mq_dma_handle);
+		return (QLT_FAILURE);
+	}
+	if (ddi_dma_addr_bind_handle(
+	    qlt->mq_req[idx].queue_mem_mq_dma_handle,
+	    NULL, qlt->mq_req[idx].queue_mem_mq_base_addr,
+	    REQUEST_QUEUE_MQ_SIZE,
+	    DDI_DMA_RDWR | DDI_DMA_CONSISTENT, DDI_DMA_SLEEP, 0,
+	    &qlt->mq_req[idx].queue_mem_mq_cookie,
+	    &ncookies) != DDI_SUCCESS) {
+		ddi_dma_mem_free(&qlt->mq_req[idx].queue_mem_mq_acc_handle);
+		ddi_dma_free_handle(&qlt->mq_req[idx].queue_mem_mq_dma_handle);
+		return (QLT_FAILURE);
+	}
+	if (ncookies != 1) {
+		(void) ddi_dma_unbind_handle(
+		    qlt->mq_req[idx].queue_mem_mq_dma_handle);
+		ddi_dma_mem_free(&qlt->mq_req[idx].queue_mem_mq_acc_handle);
+		ddi_dma_free_handle(&qlt->mq_req[idx].queue_mem_mq_dma_handle);
+		return (QLT_FAILURE);
+	}
+
+	/*
+	 * MQ Response queue
+	 */
+	if (ddi_dma_alloc_handle(qlt->dip, &qlt_queue_dma_attr_mq_rsp1,
+	    DDI_DMA_SLEEP, 0,
+	    &qlt->mq_resp[idx].queue_mem_mq_dma_handle) != DDI_SUCCESS) {
+		(void) ddi_dma_unbind_handle(
+		    qlt->mq_req[idx].queue_mem_mq_dma_handle);
+		ddi_dma_mem_free(&qlt->mq_req[idx].queue_mem_mq_acc_handle);
+		ddi_dma_free_handle(&qlt->mq_req[idx].queue_mem_mq_dma_handle);
+		return (QLT_FAILURE);
+	}
+	if (ddi_dma_mem_alloc(qlt->mq_resp[idx].queue_mem_mq_dma_handle,
+	    RESPONSE_QUEUE_MQ_SIZE,
+	    &dev_acc_attr, DDI_DMA_CONSISTENT, DDI_DMA_SLEEP, 0,
+	    &qlt->mq_resp[idx].queue_mem_mq_base_addr, &discard,
+	    &qlt->mq_resp[idx].queue_mem_mq_acc_handle) != DDI_SUCCESS) {
+		(void) ddi_dma_unbind_handle(
+		    qlt->mq_req[idx].queue_mem_mq_dma_handle);
+		ddi_dma_mem_free(&qlt->mq_req[idx].queue_mem_mq_acc_handle);
+		ddi_dma_free_handle(&qlt->mq_req[idx].queue_mem_mq_dma_handle);
+		ddi_dma_free_handle(&qlt->mq_resp[idx].queue_mem_mq_dma_handle);
+		return (QLT_FAILURE);
+	}
+	if (ddi_dma_addr_bind_handle(
+	    qlt->mq_resp[idx].queue_mem_mq_dma_handle,
+	    NULL, qlt->mq_resp[idx].queue_mem_mq_base_addr,
+	    RESPONSE_QUEUE_MQ_SIZE,
+	    DDI_DMA_RDWR | DDI_DMA_CONSISTENT, DDI_DMA_SLEEP, 0,
+	    &qlt->mq_resp[idx].queue_mem_mq_cookie,
+	    &ncookies) != DDI_SUCCESS) {
+		(void) ddi_dma_unbind_handle(
+		    qlt->mq_req[idx].queue_mem_mq_dma_handle);
+		ddi_dma_mem_free(&qlt->mq_req[idx].queue_mem_mq_acc_handle);
+		ddi_dma_free_handle(&qlt->mq_req[idx].queue_mem_mq_dma_handle);
+		ddi_dma_mem_free(&qlt->mq_resp[idx].queue_mem_mq_acc_handle);
+		ddi_dma_free_handle(&qlt->mq_resp[idx].queue_mem_mq_dma_handle);
+		return (QLT_FAILURE);
+	}
+	if (ncookies != 1) {
+		(void) ddi_dma_unbind_handle(
+		    qlt->mq_req[idx].queue_mem_mq_dma_handle);
+		ddi_dma_mem_free(&qlt->mq_req[idx].queue_mem_mq_acc_handle);
+		ddi_dma_free_handle(&qlt->mq_req[idx].queue_mem_mq_dma_handle);
+		(void) ddi_dma_unbind_handle(
+		    qlt->mq_resp[idx].queue_mem_mq_dma_handle);
+		ddi_dma_mem_free(&qlt->mq_resp[idx].queue_mem_mq_acc_handle);
+		ddi_dma_free_handle(&qlt->mq_resp[idx].queue_mem_mq_dma_handle);
+		return (QLT_FAILURE);
+	}
+
+	qlt->mq_req[idx].mq_ptr = qlt->mq_req[idx].queue_mem_mq_base_addr;
+	qlt->mq_req[idx].mq_ndx_to_fw = qlt->mq_req[idx].mq_ndx_from_fw = 0;
+	qlt->mq_req[idx].mq_available = REQUEST_QUEUE_MQ_ENTRIES - 1;
+	bzero(qlt->mq_req[idx].mq_ptr, REQUEST_QUEUE_MQ_SIZE);
+
+	qlt->mq_resp[idx].mq_ptr = qlt->mq_resp[idx].queue_mem_mq_base_addr;
+	qlt->mq_resp[idx].mq_ndx_to_fw = qlt->mq_resp[idx].mq_ndx_from_fw = 0;
+	bzero(qlt->mq_resp[idx].mq_ptr, RESPONSE_QUEUE_MQ_SIZE);
+
+	return (QLT_SUCCESS);
+}
+
 static void
 qlt_handle_verify_fw_completion(qlt_state_t *qlt, uint8_t *rsp)
 {
 	uint16_t	status;
-	char		info[QLT_INFO_LEN];
+	char		info[80];
 
 	status = QMEM_RD16(qlt, rsp+8);
 	if (status != 0) {
-		(void) snprintf(info, sizeof (info),
-		    "qlt_handle_verify_fw_completion: "
+		(void) snprintf(info, 80, "qlt_handle_verify_fw_completion: "
 		    "status:%x, rsp:%p", status, (void *)rsp);
 		if (status == 3) {
 			uint16_t error_code;
 
 			error_code = QMEM_RD16(qlt, rsp+0xA);
-			(void) snprintf(info, sizeof (info),
-			    "qlt_handle_verify_fw_completion: error code:%x",
-			    error_code);
+			(void) snprintf(info, 80, "qlt_handle_verify_fw_"
+			    "completion: error code:%x", error_code);
 		}
 	}
 }
@@ -5886,36 +9356,30 @@
 static int
 qlt_el_trace_desc_ctor(qlt_state_t *qlt)
 {
-	int	rval = DDI_SUCCESS;
+	qlt_trace_entry_t	*entry;
+	size_t			maxsize;
 
-	qlt->el_trace_desc = (qlt_el_trace_desc_t *)
-	    kmem_zalloc(sizeof (qlt_el_trace_desc_t), KM_SLEEP);
+	qlt->qlt_trace_desc =
+	    (qlt_trace_desc_t *)kmem_zalloc(
+	    sizeof (qlt_trace_desc_t), KM_SLEEP);
 
-	if (qlt->el_trace_desc == NULL) {
-		cmn_err(CE_WARN, "qlt(%d): can't construct trace descriptor",
-		    qlt->instance);
-		rval = DDI_FAILURE;
-	} else {
-		qlt->el_trace_desc->next = 0;
-		qlt->el_trace_desc->trace_buffer =
-		    (char *)kmem_zalloc(EL_TRACE_BUF_SIZE, KM_SLEEP);
+	qlt->qlt_log_entries = QL_LOG_ENTRIES;
+	maxsize = qlt->qlt_log_entries * sizeof (qlt_trace_entry_t);
+	entry = kmem_zalloc(maxsize, KM_SLEEP);
 
-		if (qlt->el_trace_desc->trace_buffer == NULL) {
-			cmn_err(CE_WARN, "qlt(%d): can't get trace buffer",
-			    qlt->instance);
-			kmem_free(qlt->el_trace_desc,
-			    sizeof (qlt_el_trace_desc_t));
-			qlt->el_trace_desc = NULL;
-			rval = DDI_FAILURE;
-		} else {
-			qlt->el_trace_desc->trace_buffer_size =
-			    EL_TRACE_BUF_SIZE;
-			mutex_init(&qlt->el_trace_desc->mutex, NULL,
-			    MUTEX_DRIVER, NULL);
-		}
-	}
+	mutex_init(&qlt->qlt_trace_desc->mutex, NULL,
+	    MUTEX_DRIVER, NULL);
 
-	return (rval);
+	qlt->qlt_trace_desc->trace_buffer = entry;
+	qlt->qlt_trace_desc->trace_buffer_size = maxsize;
+	qlt->qlt_trace_desc->nindex = 0;
+
+	qlt->qlt_trace_desc->nentries = qlt->qlt_log_entries;
+	qlt->qlt_trace_desc->start = qlt->qlt_trace_desc->end = 0;
+	qlt->qlt_trace_desc->csize = 0;
+	qlt->qlt_trace_desc->count = 0;
+
+	return (DDI_SUCCESS);
 }
 
 /*
@@ -5930,18 +9394,13 @@
 {
 	int	rval = DDI_SUCCESS;
 
-	if (qlt->el_trace_desc == NULL) {
-		cmn_err(CE_WARN, "qlt(%d): can't destroy el trace descriptor",
-		    qlt->instance);
-		rval = DDI_FAILURE;
-	} else {
-		if (qlt->el_trace_desc->trace_buffer != NULL) {
-			kmem_free(qlt->el_trace_desc->trace_buffer,
-			    qlt->el_trace_desc->trace_buffer_size);
+	if (qlt->qlt_trace_desc != NULL) {
+		if (qlt->qlt_trace_desc->trace_buffer != NULL) {
+			kmem_free(qlt->qlt_trace_desc->trace_buffer,
+			    qlt->qlt_trace_desc->trace_buffer_size);
 		}
-		mutex_destroy(&qlt->el_trace_desc->mutex);
-		kmem_free(qlt->el_trace_desc, sizeof (qlt_el_trace_desc_t));
-		qlt->el_trace_desc = NULL;
+		mutex_destroy(&qlt->qlt_trace_desc->mutex);
+		kmem_free(qlt->qlt_trace_desc, sizeof (qlt_trace_desc_t));
 	}
 
 	return (rval);
@@ -5963,190 +9422,129 @@
 void
 qlt_el_msg(qlt_state_t *qlt, const char *fn, int ce, ...)
 {
-	char		*s, *fmt = 0, *fmt1 = 0;
-	char		fmt2[EL_BUFFER_RESERVE];
-	int		rval, tmp;
-	int		tracing = 0;
-	va_list		vl;
+	char	*s, *fmt = 0, *fmt1 = 0;
 
-	/* Tracing is the default but it can be disabled. */
-	if ((rval = qlt_validate_trace_desc(qlt)) == DDI_SUCCESS) {
-		tracing = 1;
+	/*
+	 * EL_BUFFER_RESERVE 256 is the max # of bytes
+	 * that driver's log could be collected.
+	 * add 3 more buytes for safely maniplulation.
+	 */
+	char	buf[EL_BUFFER_RESERVE + 3];
+	char	buf1[QL_LOG_LENGTH];
+	size_t	tmp;
+	size_t	rval, rval1;
+	va_list	vl;
+	qlt_trace_desc_t *desc = qlt->qlt_trace_desc;
+	qlt_trace_entry_t	*entry;
+	uint32_t	cindex;
+	timespec_t	time;
+	uint32_t	count;
+	size_t		left;
 
-		mutex_enter(&qlt->el_trace_desc->mutex);
+	(void) bzero((void *)&buf[0], EL_BUFFER_RESERVE + 3);
+	fmt1 = &buf[0];
 
+	TRACE_BUFFER_LOCK(qlt);
+
+	/* locate the entry to be filled out */
+	cindex = desc->nindex;
+	entry = &desc->trace_buffer[cindex];
+
+	count = desc->count;
+
+	desc->end = desc->nindex;
+	desc->nindex++;
+	if (desc->nindex == desc->nentries) {
+		desc->nindex = 0;
+	}
+
+	if (desc->csize < desc->nentries) {
+		desc->csize ++;
+	} else {
 		/*
-		 * Ensure enough space for the string. Wrap to
-		 * start when default message allocation size
-		 * would overrun the end.
+		 * once wrapped, csize is fixed.
+		 * so we have to adjust start point
 		 */
-		if ((qlt->el_trace_desc->next + EL_BUFFER_RESERVE) >=
-		    qlt->el_trace_desc->trace_buffer_size) {
-			fmt = qlt->el_trace_desc->trace_buffer;
-			qlt->el_trace_desc->next = 0;
-		} else {
-			fmt = qlt->el_trace_desc->trace_buffer +
-			    qlt->el_trace_desc->next;
-		}
+		desc->start = desc->nindex;
 	}
 
-	/* if no buffer use the stack */
-	if (fmt == NULL) {
-		fmt = fmt2;
-	}
+	gethrestime(&time);
 
-	va_start(vl, ce);
+	rval = snprintf(fmt1, (size_t)EL_BUFFER_RESERVE,
+	    QL_BANG "%d=>QEL %s(%d,%d):: %s, ", count, QL_NAME,
+	    qlt->instance, 0, fn);
 
-	s = va_arg(vl, char *);
+	rval1 = rval;
 
-	rval = (int)snprintf(fmt, (size_t)EL_BUFFER_RESERVE,
-	    "QEL qlt(%d): %s, ", qlt->instance, fn);
-	fmt1 = fmt + rval;
-	tmp = (int)vsnprintf(fmt1,
+	va_start(vl, ce);
+	s = va_arg(vl, char *);
+	fmt = fmt1 + rval;
+	tmp = vsnprintf(fmt,
 	    (size_t)(uint32_t)((int)EL_BUFFER_RESERVE - rval), s, vl);
+	va_end(vl);
+
 	rval += tmp;
+	if (rval > QL_LOG_LENGTH - 1) {
+		left = rval - (QL_LOG_LENGTH - 1);
 
-	/*
-	 * Calculate the offset where the next message will go,
-	 * skipping the NULL.
-	 */
-	if (tracing) {
-		uint16_t next = (uint16_t)(rval += 1);
-		qlt->el_trace_desc->next += next;
-		mutex_exit(&qlt->el_trace_desc->mutex);
-	}
+		/* store the remaining string */
+		(void) strncpy(buf1, fmt1 + (QL_LOG_LENGTH - 1), left);
+		(void) strncpy(entry->buf, fmt1, (QL_LOG_LENGTH - 1));
+		entry->buf[QL_LOG_LENGTH - 1] = '\n';
 
-	if (enable_extended_logging) {
-		cmn_err(ce, fmt);
-	}
+		bcopy((void *)&time, (void *)&entry->hs_time,
+		    sizeof (timespec_t));
 
-	va_end(vl);
-}
+		/*
+		 * remaining msg will be stored in the nex entry
+		 * with same timestamp and same sequence number
+		 */
+		cindex = desc->nindex;
+		entry = &desc->trace_buffer[cindex];
 
-/*
- * qlt_dump_el_trace_buffer
- *	 Outputs extended logging trace buffer.
- *
- * Input:
- *	qlt:	adapter state pointer.
- */
-void
-qlt_dump_el_trace_buffer(qlt_state_t *qlt)
-{
-	char		*dump_start = NULL;
-	char		*dump_current = NULL;
-	char		*trace_start;
-	char		*trace_end;
-	int		wrapped = 0;
-	int		rval;
+		desc->end = desc->nindex;
+		desc->nindex++;
+		if (desc->nindex == desc->nentries) {
+			desc->nindex = 0;
+		}
 
-	mutex_enter(&qlt->el_trace_desc->mutex);
+		if (desc->csize < desc->nentries) {
+			desc->csize ++;
+		} else {
+			desc->start = desc->nindex;
+		}
 
-	rval = qlt_validate_trace_desc(qlt);
-	if (rval != NULL) {
-		cmn_err(CE_CONT, "qlt(%d) Dump EL trace - invalid desc\n",
-		    qlt->instance);
-	} else if ((dump_start = qlt_find_trace_start(qlt)) != NULL) {
-		dump_current = dump_start;
-		trace_start = qlt->el_trace_desc->trace_buffer;
-		trace_end = trace_start +
-		    qlt->el_trace_desc->trace_buffer_size;
+		(void) strncpy(&entry->buf[0], fmt1, rval1);
+		(void) strncpy(&entry->buf[rval1], &buf1[0], left);
+		entry->buf[rval1 + left] = 0;
 
-		cmn_err(CE_CONT, "qlt(%d) Dump EL trace - start %p %p\n",
-		    qlt->instance,
-		    (void *)dump_start, (void *)trace_start);
+		bcopy((void *)&time, (void *)&entry->hs_time,
+		    sizeof (timespec_t));
 
-		while (((uintptr_t)dump_current - (uintptr_t)trace_start) <=
-		    (uintptr_t)qlt->el_trace_desc->trace_buffer_size) {
-			/* Show it... */
-			cmn_err(CE_CONT, "%p - %s", (void *)dump_current,
-			    dump_current);
-			/* Make the next the current */
-			dump_current += (strlen(dump_current) + 1);
-			/* check for wrap */
-			if ((dump_current + EL_BUFFER_RESERVE) >= trace_end) {
-				dump_current = trace_start;
-				wrapped = 1;
-			} else if (wrapped) {
-				/* Don't go past next. */
-				if ((trace_start + qlt->el_trace_desc->next) <=
-				    dump_current) {
-					break;
-				}
-			} else if (*dump_current == NULL) {
-				break;
-			}
+		if (qlt->qlt_eel_level == 1) {
+			cmn_err(ce, fmt1);
 		}
-	}
-	mutex_exit(&qlt->el_trace_desc->mutex);
-}
 
-/*
- * qlt_validate_trace_desc
- *	 Ensures the extended logging trace descriptor is good.
- *
- * Input:
- *	qlt:	adapter state pointer.
- *
- * Returns:
- *	ql local function return status code.
- */
-static int
-qlt_validate_trace_desc(qlt_state_t *qlt)
-{
-	int	rval = DDI_SUCCESS;
+		desc->count++;
 
-	if (qlt->el_trace_desc == NULL) {
-		rval = DDI_FAILURE;
-	} else if (qlt->el_trace_desc->trace_buffer == NULL) {
-		rval = DDI_FAILURE;
+		TRACE_BUFFER_UNLOCK(qlt);
+		return;
 	}
-	return (rval);
-}
 
-/*
- * qlt_find_trace_start
- *	 Locate the oldest extended logging trace entry.
- *
- * Input:
- *	qlt:	adapter state pointer.
- *
- * Returns:
- *	Pointer to a string.
- *
- * Context:
- *	Kernel/Interrupt context.
- */
-static char *
-qlt_find_trace_start(qlt_state_t *qlt)
-{
-	char	*trace_start = 0;
-	char	*trace_next  = 0;
+	desc->count ++;
+	bcopy((void *)&time, (void *)&entry->hs_time,
+	    sizeof (timespec_t));
 
-	trace_next = qlt->el_trace_desc->trace_buffer +
-	    qlt->el_trace_desc->next;
+	(void) strcpy(entry->buf, fmt1);
+	entry->buf[rval] = 0;
 
-	/*
-	 * If the buffer has not wrapped next will point at a null so
-	 * start is the beginning of the buffer.  If next points at a char
-	 * then we must traverse the buffer until a null is detected and
-	 * that will be the beginning of the oldest whole object in the buffer
-	 * which is the start.
-	 */
+	TRACE_BUFFER_UNLOCK(qlt);
 
-	if ((trace_next + EL_BUFFER_RESERVE) >=
-	    (qlt->el_trace_desc->trace_buffer +
-	    qlt->el_trace_desc->trace_buffer_size)) {
-		trace_start = qlt->el_trace_desc->trace_buffer;
-	} else if (*trace_next != NULL) {
-		trace_start = trace_next + (strlen(trace_next) + 1);
-	} else {
-		trace_start = qlt->el_trace_desc->trace_buffer;
+	if (qlt->qlt_eel_level == 1) {
+		cmn_err(ce, fmt1);
 	}
-	return (trace_start);
 }
 
-
 static int
 qlt_read_int_prop(qlt_state_t *qlt, char *prop, int defval)
 {
@@ -6308,11 +9706,15 @@
 	do {
 		if (dctl-- == 0 || qlt_raw_wrt_risc_ram_word(qlt, 0x7c00, 1) !=
 		    QLT_SUCCESS) {
+			EL(qlt, "qlt_mps_reset: semaphore request fail,"
+			    " cnt=%d\n", dctl);
 			return;
 		}
 		if (qlt_raw_rd_risc_ram_word(qlt, 0x7c00, &data) !=
 		    QLT_SUCCESS) {
 			(void) qlt_raw_wrt_risc_ram_word(qlt, 0x7c00, 0);
+			EL(qlt, "qlt_mps_reset: semaphore read fail,"
+			    " cnt=%d\n", dctl);
 			return;
 		}
 	} while (!(data & BIT_0));
@@ -6324,6 +9726,8 @@
 			data |= dctl & 0xe0;
 			(void) qlt_raw_wrt_risc_ram_word(qlt, 0x7A15, data);
 		}
+	} else {
+		EL(qlt, "qlt_mps_reset: read 0x7a15 failed.\n");
 	}
 	(void) qlt_raw_wrt_risc_ram_word(qlt, 0x7c00, 0);
 }
@@ -6402,6 +9806,13 @@
 		EL(qlt, "wwnn overloaded.\n");
 	}
 
+	/* configure extended logging from conf file */
+	if ((cnt = qlt_read_int_instance_prop(qlt, "extended-logging",
+	    defval)) != defval) {
+		qlt->qlt_eel_level = (uint8_t)(cnt & 0xff);
+		EL(qlt, "extended error logging=%d\n", cnt);
+	}
+
 	if ((cnt = qlt_read_int_instance_prop(qlt, "bucketcnt2k", defval)) !=
 	    defval) {
 		qlt->qlt_bucketcnt[0] = cnt;
